## ros-melodic-diagnostic-aggregator 1.9.7

=== CMakeLists.txt ===
# http://ros.org/doc/groovy/api/catkin/html/user_guide/supposed.html
cmake_minimum_required(VERSION 2.8.3)
project(diagnostic_aggregator)

# Load catkin and all dependencies required for this package
find_package(catkin REQUIRED diagnostic_msgs pluginlib roscpp rospy xmlrpcpp bondcpp)
catkin_package(DEPENDS diagnostic_msgs pluginlib roscpp rospy xmlrpcpp bondcpp
    INCLUDE_DIRS include
    LIBRARIES ${PROJECT_NAME})

set(REQUIRED_diagnostic_msgs_VERSION_Indigo "1.11.9")
set(REQUIRED_diagnostic_msgs_VERSION_Jade "1.12.4")
if( ${diagnostic_msgs_VERSION} VERSION_LESS ${REQUIRED_diagnostic_msgs_VERSION_Indigo})
  message(FATAL_ERROR "diagnostic_msgs version ${REQUIRED_diagnostic_msgs_VERSION_Indigo} or newer is required to build diagnotic_aggregator on ROS Indigo")
endif()
if( (${diagnostic_msgs_VERSION} VERSION_EQUAL "1.12.0") OR
    (${diagnostic_msgs_VERSION} VERSION_GREATER "1.12.0" AND
     ${diagnostic_msgs_VERSION} VERSION_LESS ${REQUIRED_diagnostic_msgs_VERSION_Jade}))
  message(FATAL_ERROR "diagnostic_msgs version ${REQUIRED_diagnostic_msgs_VERSION_Jade} or newer is required to build diagnotic_aggregator on ROS Jade")
endif()

find_package(Boost REQUIRED COMPONENTS system)
include_directories(include ${catkin_INCLUDE_DIRS} ${Boost_INCLUDE_DIRS})

set(LOCAL_GTEST_DIR "gtest-1.7.0")
# gtest could be included in ${catkin_INCLUDE_DIRS}, prepend local gtest include directory so it's searched first
include_directories(BEFORE ${LOCAL_GTEST_DIR}/include)

add_library(${PROJECT_NAME}
  src/status_item.cpp
  src/analyzer_group.cpp
  src/generic_analyzer.cpp
  src/discard_analyzer.cpp
  src/ignore_analyzer.cpp
  src/aggregator.cpp)
target_link_libraries(diagnostic_aggregator ${Boost_LIBRARIES}
                                            ${catkin_LIBRARIES}
)
add_dependencies(${PROJECT_NAME} diagnostic_msgs_generate_messages_cpp)

# Aggregator node 
add_executable(aggregator_node src/aggregator_node.cpp)
target_link_libraries(aggregator_node ${catkin_LIBRARIES}
                                      ${PROJECT_NAME}
)

# Analyzer loader allows other users to test that Analyzers load
add_executable(analyzer_loader test/analyzer_loader.cpp ${LOCAL_GTEST_DIR}/gtest-all.cc)
target_link_libraries(analyzer_loader diagnostic_aggregator)

if(CATKIN_ENABLE_TESTING)
  find_package(rostest REQUIRED)
  add_rostest(test/launch/test_agg.launch)
  add_rostest(test/launch/test_add_agg.launch)

  # Test Analyzer loader
  add_rostest(test/launch/test_loader.launch)
  add_rostest(test/launch/test_expected_stale.launch)
  add_rostest(test/launch/test_multiple_match.launch)
endif()

catkin_install_python(
        PROGRAMS scripts/add_analyzers
        DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)
install(DIRECTORY include/${PROJECT_NAME}/
        DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
)
install(FILES analyzer_plugins.xml
        DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)
install(TARGETS ${PROJECT_NAME}
        DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
)
install(TARGETS aggregator_node analyzer_loader
        DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

=== debian/changelog ===
ros-melodic-diagnostic-aggregator (1.9.7-1bionic) bionic; urgency=high



 -- Austin Hendrix <namniart@gmail.com>  Wed, 02 Sep 2020 22:00:00 -0000

ros-melodic-diagnostic-aggregator (1.9.6-1bionic) bionic; urgency=high

  * Extend initial connect timeout for add_analyzers (#129 <https://github.com/ros/diagnostics/issues/129>)
  * Contributors: Mike Purvis

 -- Austin Hendrix <namniart@gmail.com>  Mon, 17 Aug 2020 22:00:00 -0000

ros-melodic-diagnostic-aggregator (1.9.5-1bionic) bionic; urgency=high

  * Update CMakeLists.txt to search for local gtest first
  * Fix copyright and remove unused imports
  * Improvement by using opertors instead of aliases (Closes #95 <https://github.com/ros/diagnostics/issues/95>
  * Contributors: Austin, Guglielmo Gemignani, James Xu, Martin Pecka, Sean Yen

 -- Austin Hendrix <namniart@gmail.com>  Sun, 09 Aug 2020 22:00:00 -0000

ros-melodic-diagnostic-aggregator (1.9.3-1bionic) bionic; urgency=high

  * Merge pull request #79 <https://github.com/ros/diagnostics/issues/79> from nlamprian/indigo-devel
    Fixed base_path handling
  * Merge pull request #82 <https://github.com/ros/diagnostics/issues/82> from moriarty/fix-pluginlib-deprecated-headers
    [Aggregator] Fixes C++ Warnings (pluginlib)
  * [Aggregator] Fixes C++ Warnings (pluginlib)
    This fixes the following warnings:
    warning: Including header <pluginlib/class_list_macros.h>
    is deprecated,include <pluginlib/class_list_macros.hpp> instead. [-Wcpp]
    warning: Including header <pluginlib/class_loader.h>
    is deprecated, include <pluginlib/class_loader.hpp> instead. [-Wcpp]
    The .hpp files have been backported to indigo
  * Fixed base_path handling
  * Upstream missing changes to add_analyzers
  * Contributors: Alexander Moriarty, Austin, Nick Lamprianidis, trainman419

 -- Austin Hendrix <namniart@gmail.com>  Tue, 01 May 2018 22:00:00 -0000

ros-melodic-diagnostic-aggregator (1.9.2-1bionic) bionic; urgency=high



 -- Austin Hendrix <namniart@gmail.com>  Fri, 14 Jul 2017 22:00:00 -0000

ros-melodic-diagnostic-aggregator (1.9.1-1bionic) bionic; urgency=high

  * Add queue size parameters on Publishers
  * add_analyzers improvements
    * Warning message when bond is broken
    * Per-bond topics to avoid queue length issues
  * Option to make diagnostics in Other an error
  * Contributors: trainman419

 -- Austin Hendrix <namniart@gmail.com>  Fri, 14 Jul 2017 22:00:00 -0000

ros-melodic-diagnostic-aggregator (1.9.0-1bionic) bionic; urgency=high

  * Longer settling time
  * Fix race condition in unload
  * Fix cmake warnings
  * make rostest in CMakeLists optional (ros/rosdistro#3010 <https://github.com/ros/rosdistro/issues/3010>)
  * Changed all deprecated PLUGINLIB_DECLARE_CLASS to PLUGINLIB_EXPORT_CLASS macros
  * Contributors: Aris Synodinos, Lukas Bulwahn, trainman419

 -- Austin Hendrix <namniart@gmail.com>  Mon, 24 Apr 2017 22:00:00 -0000

ros-melodic-diagnostic-aggregator (1.8.10-1bionic) bionic; urgency=high

  * Start bond after add_diagnostics service is available
  * Contributors: Mustafa Safri

 -- Austin Hendrix <namniart@gmail.com>  Mon, 13 Jun 2016 22:00:00 -0000

ros-melodic-diagnostic-aggregator (1.8.9-1bionic) bionic; urgency=high

  * Add version dependencies in package.xml
  * Add version check in cmake
  * Add functionality for dynamically adding analyzers
  * Contributors: Michal Staniaszek, trainman419

 -- Austin Hendrix <namniart@gmail.com>  Tue, 01 Mar 2016 23:00:00 -0000

ros-melodic-diagnostic-aggregator (1.8.8-1bionic) bionic; urgency=high

  * Fix #17 <https://github.com/ros/diagnostics/issues/17>
  * Contributors: trainman419

 -- Austin Hendrix <namniart@gmail.com>  Wed, 05 Aug 2015 22:00:00 -0000

ros-melodic-diagnostic-aggregator (1.8.7-1bionic) bionic; urgency=high

  * Upgrade to gtest 1.7.0
  * Contributors: trainman419

 -- Austin Hendrix <namniart@gmail.com>  Thu, 08 Jan 2015 23:00:00 -0000

ros-melodic-diagnostic-aggregator (1.8.6-1bionic) bionic; urgency=high



 -- Austin Hendrix <namniart@gmail.com>  Tue, 09 Dec 2014 23:00:00 -0000

ros-melodic-diagnostic-aggregator (1.8.5-1bionic) bionic; urgency=high

  * Include gtest source directly
  * Contributors: trainman419

 -- Austin Hendrix <namniart@gmail.com>  Mon, 28 Jul 2014 22:00:00 -0000

ros-melodic-diagnostic-aggregator (1.8.4-1bionic) bionic; urgency=high

  * Install analyzer_loader. Fixes #24 <https://github.com/ros/diagnostics/issues/24>
  * Add dependency on message generation
  * Remove stray architechture_independent flags
    This flag should be used for package which do not contain
    architecture-specific files. Compiled binaries are such a file, and
    these packages contain them.
  * Contributors: Jon Binney, Scott K Logan, trainman419

 -- Austin Hendrix <namniart@gmail.com>  Thu, 24 Jul 2014 18:51:00 -0000

ros-melodic-diagnostic-aggregator (1.8.3-1bionic) bionic; urgency=high

  * Fix stale aggregation bug
  * Clean up stale check
    Fixes #21 <https://github.com/ros/diagnostics/issues/21>
  * Contributors: Austin Hendrix

 -- Austin Hendrix <namniart@gmail.com>  Tue, 22 Apr 2014 22:00:00 -0000

ros-melodic-diagnostic-aggregator (1.8.2-1bionic) bionic; urgency=high

  * Fix linking. All tests pass.
    Fixes #12 <https://github.com/ros/diagnostics/issues/12>
  * Most tests pass
  * Contributors: Austin Hendrix

 -- Austin Hendrix <namniart@gmail.com>  Mon, 07 Apr 2014 22:00:00 -0000

ros-melodic-diagnostic-aggregator (1.8.1-1bionic) bionic; urgency=high

  * Add myself as maintainer
  * check for CATKIN_ENABLE_TESTING
  * Contributors: Austin Hendrix, Lukas Bulwahn

 -- Austin Hendrix <namniart@gmail.com>  Sun, 06 Apr 2014 22:00:00 -0000

ros-melodic-diagnostic-aggregator (1.8.0-1bionic) bionic; urgency=high



 -- Austin Hendrix <namniart@gmail.com>  Tue, 02 Apr 2013 22:00:00 -0000

ros-melodic-diagnostic-aggregator (1.7.11-1bionic) bionic; urgency=high

  * Install analyzer_loader
  * diagnostic_aggregator) Removed redundancy in package.xml.


=== debian/control ===
Source: ros-melodic-diagnostic-aggregator
Section: misc
Priority: optional
Maintainer: Austin Hendrix <namniart@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-melodic-bondcpp, ros-melodic-bondpy, ros-melodic-catkin (>= 0.5.68), ros-melodic-diagnostic-msgs (>= 1.11.9), ros-melodic-pluginlib, ros-melodic-roscpp, ros-melodic-rospy, ros-melodic-rostest, ros-melodic-xmlrpcpp
Homepage: http://www.ros.org/wiki/diagnostic_aggregator
Standards-Version: 3.9.2

Package: ros-melodic-diagnostic-aggregator
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-melodic-bondcpp, ros-melodic-bondpy, ros-melodic-diagnostic-msgs (>= 1.11.9), ros-melodic-pluginlib, ros-melodic-roscpp, ros-melodic-rospy, ros-melodic-xmlrpcpp
Description: diagnostic_aggregator

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-diagnostic-aggregator//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install
